<template>
  <div id="teacher_lecture_live_wrapper" class="bt-container" style="height: 100%; width: 1000px">
      <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
        <el-breadcrumb-item>{{ $t('SGROUP.TITLE') }}</el-breadcrumb-item>
        <el-breadcrumb-item>{{ title }}</el-breadcrumb-item>
      </el-breadcrumb>
      <br/>
    <h2 class="page-title" style="margin-top: -20px;">{{ $t('SGROUP.EDITTITLE') }}</h2>
    <div style="display:inline; float: right; margin-top:-40px;">   
      <el-button size="small" @click="onClick('BACK')" :class="$attachReactablePostfix('el-btn')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
    </div> 
    
    <el-form :model="room" ref="elForm" label-position="left" label-width="190px" style="max-width: 800px;" class="elForm-label">
      <el-form-item :label="$t('SGROUP.NAME')">
        <el-input v-model="room.name" class="subject-title"></el-input>
      </el-form-item>
      <el-form-item :label="$t('SGROUP.TYPE')">
        <el-radio-group v-model="room.type" :disabled="true">
          <el-radio :label="0">{{ $t('SGROUP.REG') }}</el-radio>
          <el-radio :label="1">{{ $t('SGROUP.TEMP') }}</el-radio>
        </el-radio-group>
      </el-form-item>

      <el-form-item :label="$t('SGROUP.MAX')">
        <el-input v-model="room.max_occupancy" type="number" min=1 max=100></el-input>
      </el-form-item>

      <el-form-item :label="$t('SGROUP.PASSWORD')">
        <el-input v-model="room.password"></el-input>
      </el-form-item>

      <!-- <el-form-item :label="$t('SGROUP.AUTH')">       // 버그로 적합한 사람도 못들어가는 현상이 있어서 임시 잠금 
        <el-table :data="listOfStudents" border>
          <el-table-column label="이름" prop="name" />
          <el-table-column label="이메일" prop="email_id" />
          <el-table-column label="권한 부여" prop="auth" >
            <template slot-scope="scope">
            <el-checkbox
              v-model="scope.row.auth"
              :key="scope.row.email_id"
              @change="handleCheckedMaterialChange(scope.row);"
              >권한 여부
            </el-checkbox>
            </template>
         </el-table-column>
        </el-table>
      </el-form-item> -->
      <el-form-item>
        <el-button
          type="primary"
          class="subject-btn"
          @click="onClick('EDIT')"          
        >
          {{ $t('SGROUP.EDIT') }}
        </el-button>
      </el-form-item>
    </el-form>
  </div>     
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';
import LectureList from '../partials/LectureList';
import utils from '../../utils';
import lectureService from '../../services/lectureService';
import authService from '../../services/authService';
import userService from '../../services/userService';
import classService from '../../services/classService';
import { createVariableStatement } from 'typescript';


export default {
  name: 'SGroupRoomEdit',
  async created() {
    const vm = this;
    vm.roomId = vm.$route.params.roomId;
    vm.myId = await utils.getUserIdFromJwt();
    const myInfo = await userService.getUserNameByUserId({
      userId : vm.myId,
    })
    vm.mytype = myInfo.data.userInfo.type;
    vm.myname = myInfo.data.userInfo.name;

    var targetUser = 0;
    var isIn =false;
    const roomInfo = await lectureService.newgetSmallMeetingRoomList({
      classId : vm.classId,
    });
    roomInfo.data.forEach(x => {
      if(x.room_id == vm.roomId){
        targetUser = x.user_id;
        vm.room = x;
        isIn = true;
      }
    });

    //URL로 접근한 경우, DB안에 없는 room을 수정하는거 방지
    if(!isIn){
      vm.$router.push({ name: 'LandingPage' });
    }
    //학생인 경우 생성자만 접근 가능
    if(vm.mytype === 0){
      if(targetUser != vm.myId){
        vm.$router.push({ name: 'LandingPage' });
      }    
    }
    vm.title = vm.room.name;

    const tmp = await lectureService.getPermittedUserListOfClass({
      classId : vm.classId,
    })
    tmp.data.forEach(x => {
      vm.authStudents.push(x)
    });

    //만든 사람은 체크박스에서 지우고, 다른 방에 권한 있는 사람 역시 체크박스에서 지움
    //자기 방에 이미 권한 있던 사람들은 냅두고 체크 되게끔
    const listOfStudents = await lectureService.getWholeStudents({
      id: vm.$route.params.lectureId,
    });
    listOfStudents.data.forEach(x => {
      let isin = false;
      let sameRoom = false;
      vm.count += 1;
      vm.authStudents.forEach(y => {
        if (x.user_id === y.user_id) {
          isin = true; // 권한을 받은 학생
          if (y.room_id === parseInt(vm.roomId)) {
            sameRoom = true; // 권한을 받았는데 같은 방
          }
        }
      });
      if (isin && sameRoom) { // 같은 방이고 권한도 있는 사람
        x.auth = true;
        vm.listOfStudents.push(x);
      }
      if (!isin && (x.user_id !== vm.room.user_id)) { // 권한이 없고 방 생성자가 아닌 사람
        x.auth = false;
        vm.listOfStudents.push(x);
      }
    });
   },
  components: {
    LectureList,
  },
  data() {
    return {
      roomId: 0,     
      room: {},   
      title: '',
      checked: false,
      centerDialogVisible: false,
      listOfStudents: [],      
      count: 0,
      myId: 0,
      mytype: 0,
      myname: '',
      authStudents: [],
      lectureId: this.$router.currentRoute.params.lectureId,
    };
  },
  async mounted() {
    const vm = this;
  },
  computed: {
    ...mapState('NNclass', [
      'teachingClassList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('NNclass', [
      'getClass',
      'getMyClassLists',
      'deleteLectureFromClass',
    ]),
    handleCheckedMaterialChange(value) {
      const vm = this;
    },
    async onClick(type) {
      const vm = this;
      switch (type) {
        case 'BACK': {
          location.href = "javascript:history.back();";
          break;          
        }       
        case 'EDIT': {
          const max_num = vm.room.max_occupancy;
          if (max_num > vm.count+1 || max_num < 1 || max_num.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.INPUT_RIGHT_NUM'),
              //한 줄 더 하고싶...
              type: 'warning',
              duration: 3000,
            });
            this.$refs.elForm.resetFields();
            return;
          }
          try {
            //권한 초기화
            await lectureService.deleteEntrancePermission({
              roomId : vm.roomId,
            })
            var cnt=0;
            //학생일 때는 생성자까지 포함
            if(vm.mytype===0){
              cnt ++;
            }
            //권한 수 체크, //권한 테이블 넘기기
            vm.listOfStudents.forEach(async(x) => {
              if((x.auth === true) && (x.user_id != vm.myId)){
                cnt++;   
                await lectureService.postEntrancePermission({
                    roomId : vm.roomId,
                    userId : x.user_id,
                });
              }
            }); 
            
            //권한 수가 최대인원보다 크면 error, 시스템 고정 인원보다 클 시 error
            if(cnt > vm.room.max_occupancy){
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.SGROUP_AUTH_FAIL'),
                type: 'warning',
                duration: 3000,                
              });
              this.$refs.elForm.resetFields();
              return;              
            }
            //강사일 때는 권한 수 = 
            //수정
            await lectureService.putSmallMeetingRoom({
              roomId : vm.roomId,
              name : vm.room.name,
              max_occupancy : vm.room.max_occupancy,
              password: vm.room.password,
            })          
            
            vm.$router.go(-1);          
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.SGROUP_EDIT_ERROR'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }

          /*if(cnt > max_num){
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.WRONG_CHECK'),
              type: 'warning',
            });
            this.$refs.elForm.resetFields();
            return;            
          }*/

          break;
        } 
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    /*
    async categoryNone() {
      const vm = this;
      if (vm.input.checked === true) {
        vm.input.boolean = true;
      } else {
        vm.input.boolean = false;
      }
      const teacherNameLists = await masterService.getUserLists(1,
        vm.input.university_name, vm.input.department_name);
      vm.input.teacher_list = teacherNameLists.data;
    },    */
  },
};
</script>      